.msg-list-scrollouter {
  height: calc(100% - 9.5rem);
  overflow-y: auto;
  overflow-x: hidden;
  will-change: scroll-position;
}

[data-mode="search"] .msg-list-scrollouter {
  height: calc(100% - 13.5rem);
}

.msg-list-scrollinner {
  /* Give it a z-index of 0 so that all its contents are forced into a single stacking
     context. This simplifies display list construction because our many positioned
     descendants can be clipped as a single group instead of independently.
     XXX we can take this out when Gecko bug 841192 is fixed. */
  position: relative;
  z-index: 0;
}

/* Have enough scroll space to have the search bit pull out. */
.msg-list-scroll-padding-top {
  height: 5.6rem;
}
/* Have enough space at the bottom for the last message to not be under the
   action bar. */
.msg-list-scroll-padding-bottom {
  height: 4rem;
}

[data-mode="search"] .msg-search-tease-bar {
  display: none;
}

/* For search filters, make sure the contents do not line break and overflow
outside their given areas. This is particularly important for some locales.
Do not want to set styles on the inner a tags to force ellipsis since it ends
up with ellipsis in some ways for most languages, even English, where just using
an overflow hide is enough to allow seeing the whole word in some cases. See
bug 1033628 for more details. */
.msg-search-filter {
  white-space: nowrap;
  overflow: hidden;
}

/* When card is slightly shown when folder card is center,
   be sure any inputs do not accept clicks/taps that would
   mess up the transition back to the message list. Also
   disable scrolling of the list */
.card-message-list.after input,
.card-message-list.after .msg-list-scrollouter {
  pointer-events: none;
}

.msg-no-subject {
  font-style: italic;
}

/* Sections horizontally chop up the item: unread, details, icons, avatar.
 * We have 320 horizontal pixels to play with.
 */
.msg-header-item {
  display: block;
  position: absolute;
  width: 100%;
  height: 8rem;
}
.msg-header-item:active {
  background-color: #b1f1ff;
}

/*
Default data placeholder items. To limit scrolling
impact, these styles should not be ones that trigger
reflows. Foreground/background colors should be safe.
 */
.msg-header-item.default-data .msg-header-author {
  color: #e7e8e9;
}
.msg-header-item.default-data .msg-header-subject {
  color: #e7e8e9;
}
.msg-header-item.default-data .msg-header-snippet {
  color: #e7e8e9;
}
.msg-header-item.default-data .msg-header-date {
  color: white;
}

.msg-header-unread-section {
  position: absolute;
  top: 50%;
  left: 1rem;
  display: inline-block;
  height: .9rem;
  width: .9rem;
  margin-top: -.45rem;
  border-radius: 50%;
}

.msg-header-item.unread .msg-header-unread-section {
  background-color: #2fc9ec;
}

.msg-header-details-section {
  -moz-box-sizing: border-box;
  position: absolute;
  top: 0;
  left: 1.5rem;
  width: calc(100% - 3rem);
  height: 100%;
  font-size: 1.6rem;
  line-height: 2rem;
  padding: 1rem 0 0 1.5rem;
  border-bottom: 0.1rem solid #f2f2f1;
}
.msg-header-icons-section {
  display: block;
  position: absolute;
  top: 0;
  right: 2.8rem; /* The width of the avatar-section. */
  width: 2rem;
  height: 100%;
  padding-top: 2.5rem;
}
.msg-header-avatar-section {
  display: block;
  position: absolute;
  top: 0;
  right: 0;
  width: 2.8rem;
  height: 100%;
}

.msg-header-author-and-date {
  display: table;
  table-layout: fixed;
  width: -moz-available;
}

.msg-header-author {
  font-size: 1.9rem;
  font-weight: normal;
  color: #131313;
  display: table-cell;
  width: -moz-available;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

.msg-header-item.unread .msg-header-author {
  font-weight: 500;
}

.msg-header-date {
  color: #8f8f8f;
  font-size: 1.5rem;
  font-weight: 400;
  display: table-cell;
  width: -moz-min-content;
  white-space: nowrap;
}
.msg-header-item.unread .msg-header-date {
  color: #008eab;
}

.msg-header-subject {
  display: block;
  color: #131313;
  font-size: 1.5rem;
  font-weight: normal;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}
.msg-header-snippet {
  display: block;
  color: #858585;
  font-size: 1.5rem;
  font-weight: 400;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}
/* Give space for icons on right if they need to be displayed. */
.msg-header-subject.icon-short,
.msg-header-snippet.icon-short {
  margin-right: 1.6rem;
}

.msg-header-star {
  display: block;
  color: #888844;
  font-size: 150%;
}
.msg-header-star-starred {
  background: url("images/icons/message-list-star.png") no-repeat center / 2rem;
  position: absolute;
  right: -2rem;
  width: 2rem;
  height: 2rem;
  top: 3rem;
}
.msg-header-attachments {
  display: block;
}
.msg-header-attachments-yes {
  background: url("images/icons/message-list-attachment.png") no-repeat center / 2rem;
  position: absolute;
  right: -2rem;
  width: 2rem;
  height: 2rem;
  top: 5rem;
}

.msg-envelope-bar {
  width: 100%;
  font-size: 1.4rem;
  color: #707070;
}

.msg-envelope-line {
  padding: 0 1.5rem;
  background-color: #f2f2f2;
}

.msg-envelope-from-line {
  padding-top: 0.6rem;
}

.msg-envelope-details {
  padding-bottom: 0.8rem;
  background-color: #f2f2f2;
}

.msg-envelope-date {
  font-size: 1.4rem;
  color: #657073;
}

.msg-envelope-key {
  display: inline-block;
  height: 4rem;
  line-height: 4rem;
  vertical-align: middle;
}

.msg-envelope-key::after {
  content: ":";
}


.msg-envelope-subject-container {
  margin: 1rem 1.5rem;
  padding-bottom: 1rem;
  border-bottom: 0.1rem solid #f2f2f1;
}

.msg-envelope-subject {
  margin: 1rem 0;
  font-size: 1.6rem;
  font-weight: 500;
  color: #5f5f5f;
  word-wrap: break-word;
}

.msg-body-container {
  white-space: pre-wrap;
  font-size: 1.6rem;
  line-height: 2rem;
  margin: 1rem 1.5rem;
  word-wrap: break-word;
}

.msg-peep-bubble {
  display: inline-block;
  margin: 0.8rem 0.3rem;
  padding: 0.4rem 0.8rem;
  border: 0;
  border-radius: 1.4rem;
  font-size: 1.5rem;
  font-style: italic;
  color: #2c2c2c;
  background-color: white;
}
.msg-peep-bubble:active {
  color: white;
  background-color: #00aacc;
}

.msg-peep-bubble * {
  pointer-events: none;
}

.card-message-reader .msg-body-container > progress {
  display: block;
  margin: 0 auto;
}

.card-message-reader .scrollregion-below-header {
  height: calc(100% - 9.5rem);
}

.msg-attachments-container {
  margin: 0.6rem 1.5rem 1.5rem 1.5rem;
  padding: 0;
  border-bottom: 0.1rem solid #f2f2f1;
}

/* More specific selector to override shared styles */
.msg-attachments-container .msg-attachment-item {
  list-style-type: none;
  height: 4rem;
  min-height: 4rem;
  border-bottom: none;
}

.msg-attachment-icon {
  display: block;
  float: left;
  background: url("images/icons/icon_default.png") no-repeat center left / 3rem auto;
  width: 3.6rem;
  height: 4rem;
}
.mime-image .msg-attachment-icon {
  background-image: url("images/icons/icon_image.png");
}
.mime-audio .msg-attachment-icon {
  background-image: url("images/icons/icon_music.png");
}
.mime-video .msg-attachment-icon {
  background-image: url("images/icons/icon_video.png");
}

.msg-attachment-filename,
.msg-attachment-filesize {
  display: block;
  clear: right;
  overflow: hidden;
  text-overflow: ellipsis;
  max-width: calc(100% - 9rem);
  white-space: nowrap;
  font-size: 1.4rem;
  font-weight: normal;
  color: #393d3e;
}

.msg-attachment-filename {
  padding-top: 0.4rem;
}

.msg-attachment-filesize {
  max-width: 6.5rem;
  color: #a6a6a6;
}

.msg-attachment-item[state="downloadable"]  > .msg-attachment-download {
  display: inline-block;
}
.msg-attachment-item[state="downloading"]  > .msg-attachment-downloading {
  display: inline-block;
}
.msg-attachment-item[state="downloaded"]  > .msg-attachment-view {
  display: inline-block;
}

.msg-attachment-download {
  display: none;
  width: 3.5rem;
  margin-bottom: 0;
  position: absolute;
  top: 0;
  right: -0.3rem;
  border: 0;
  background: transparent;
  overflow: hidden;
}
.msg-attachment-downloading {
  display: none;
  margin-bottom: 0;
  position: absolute;
  top: 0.6rem;
  right: 0;
}
.msg-attachment-view {
  display: none;
  width: 3.5rem;
  margin-bottom: 0;
  position: absolute;
  top: 0;
  right: -0.3rem;
  border: 0;
  background: transparent;
  overflow: hidden;
}

.msg-attachment-too-large { display: none; }
.msg-attachment-item[state="toolarge"] { height: auto; }
.msg-attachment-item[state="toolarge"] > .msg-attachment-too-large {
  display: block;
  line-height: 1;
  color: rgba(0, 0, 0, 0.5);
}
.msg-attachment-item[state="toolarge"]  > .msg-attachment-download {
  display: inline-block;
  opacity: 0.3;
  background: none;
  margin-top: 0.6rem;
}

.moz-external-link {
  color: #00aacc;
  cursor: pointer;
}

.msg-body-content {
  color: #333333;
  margin: 0.4rem 0;
}
.msg-body-signature {
  color: #808080;
  margin: 0.4rem 0;
}
.msg-body-leadin {
  color: gray;
  margin: 0.4rem 0;
}
.msg-body-q1, .msg-body-q2, .msg-body-q3, .msg-body-q4,
.msg-body-q5, .msg-body-q6, .msg-body-q7, .msg-body-q8, .msg-body-q9 {
  color: #808080;
  padding: 0.2rem;
  margin: 0.4rem 0;
}
.msg-body-q1 {
  border-left: 0.1rem solid gray;
}
.msg-body-q2 {
  border-left: 0.2rem solid gray;
}
.msg-body-q3 {
  border-left: 0.3rem solid gray;
}
.msg-body-q4 {
  border-left: 0.4rem solid gray;
}
.msg-body-q5 {
  border-left: 0.5rem solid gray;
}
.msg-body-q6 {
  border-left: 0.6rem solid gray;
}
.msg-body-q7 {
  border-left: 0.7rem solid gray;
}
.msg-body-q8 {
  border-left: 0.8rem solid gray;
}
.msg-body-q9 {
  border-left: 0.9rem solid gray;
}
.msg-body-disclaimer, .msg-body-list, .msg-body-product, .msg-body-ads {
  color: gray;
  margin: 0.4rem 0;
}

.msg-reader-load-infobar {
  position: absolute;
  -moz-box-sizing: border-box;
  color: white;
  font-size: 1.2rem;
  left: 0;
  bottom: 4.8rem;
  width: 100%;
  /* we do not specify a height because text may be more than 1 line high */
  line-height: 2.2rem;
  padding: 0.8rem 1.6rem;
  background-color: #424242;;
}

/* For WVGA (800 x 480) */
.msg-list-action-toolbar .msg-refresh-btn:after {
  content: '';
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 4.4rem;
  display: block;
  padding-bottom: 0.1rem;
  background: url("images/icons/refresh.png") no-repeat center center / 3rem auto;
}

.msg-list-action-toolbar .msg-refresh-btn:after {
  opacity: 1;
}

@media all and (min-device-width: 320px) and (max-device-width: 359px) {
  .msg-refresh-btn:after {
    height: 100%;
    padding-bottom: 0;
    background-size: 3rem;
  }
}

.msg-refresh-btn[data-state="synchronizing"]:after {
  animation: 0.9s msg-refresh-rotate infinite steps(30);
}

@keyframes msg-refresh-rotate {
  from { transform: rotate(1deg); }
  to   { transform: rotate(360deg); }
}

.bb-tablist li .icon {
  background-position: 50% 50%;
}

.bb-tablist .msg-last-sync {
  text-align: center;
  line-height: 4.5rem;
  color: #5f5f5f;
  flex: 2 2 0;
  font-size: 1.3rem;
  font-style: italic;
}

.msg-last-sync.long .msg-last-synced-label,
.msg-last-sync.long .msg-last-synced-value {
  display: block;
  line-height: 1.5rem;
}

.msg-last-sync.long .msg-last-synced-label {
  margin-top: 0.7rem;
}

.bb-tablist .icon.msg-edit-btn {
  background-image: url("images/icons/edit-mode.png");
  background-position: 50% 45%;
  background-size: 3rem auto;
}

.bb-tablist .msg-star-btn {
  background-image: url("images/icons/star.png");
}
.bb-tablist .msg-star-btn-on {
  background-image: url("images/icons/star_on.png");
}

.bb-tablist .msg-mark-read-btn {
  background-image: url("images/icons/mark.png");
}

/* Scrollable Area has to have a solid
  * opaque background to optimize Gecko.
  * See Bug 962699. */
.msg-messages-container {
  position: relative;
  background-color: #fff;
  overflow: hidden;
}

.bb-tablist .msg-delete-btn {
  background-image: url("images/icons/delete.png");
}

.bb-tablist .msg-move-btn {
  background-image: url("images/icons/move.png");
}

.bb-tablist .msg-forward-btn {
  background-image: url("images/icons/forward.png");
}

.bb-tablist .msg-reply-btn {
  background-image: url("images/icons/reply.png");
}

/* Message list edit mode layout control */
.msg-messages-container label.negative {
  height: 8rem;
  width: 4rem;
  display: none;
  pointer-events: none;
}
.msg-messages-container.show-edit label.negative {
  display: inline-block;
}

.msg-messages-container.show-edit .msg-header-unread-section {
  left: 3.9rem;
}
.msg-messages-container.show-edit .msg-header-details-section {
  padding-left: 4.5rem;
}

/*
  Empty message-list container
*/
.msg-list-empty-container {
  position: absolute;
  top: 9rem;
  left: 1.5rem;
  right: 1.5rem;
  width: calc(100% - 3rem);
  height: 20rem;
}

.msg-list-empty-message-text {
  position: relative;
  top: 2.8rem;
  margin: 0 auto;
  padding: 1rem 1.5rem;
  color: #010101;
  font-weight: lighter;
  font-size: 2.4rem;
  border-top: 0.1rem solid #bebebe;
}

.msg-messages-sync-container > p,
.msg-list-empty {
  height: 8rem;
  padding: 0;
  margin: 0;
  font-weight: 500;
  font-size: 1.5rem;
  line-height: 8rem;
}
.msg-list-empty {
  position: absolute;
  top: 40%;
}

.msg-messages-sync-container > .msg-messages-syncing,
.msg-messages-sync-container > .msg-messages-sync-more {
  width: calc(100% - 3rem);
  margin: 0 auto;
  text-align: center;
}

.msg-messages-sync-more {
  height: 8rem;
  padding: 0;
  margin: 0;
  font-weight: 500;
  font-size: 1.5rem;
  line-height: 8rem;
}
.msg-messages-sync-more > span {
  margin: 0 3rem;
}

.msg-list-topbar {
  -moz-box-sizing: border-box;
  position: absolute;
  top: 5rem;
  left: 0;
  width: 100%;
  padding: 0.6rem 3rem;
  color: #fff;
  font-size: 1.4rem;
  font-weight: 500;
  line-height: 2.4rem;
  background-color: #00aacc;
  z-index: 10;
}

.msg-reply-menu button:before {
  content: "";
  display: block;
  float: left;
  width: 3rem;
  height: 3rem;
  margin: 0.5rem 1rem 0 0;
  background-repeat: no-repeat;
  background-position: center center;
  background-size: 3rem auto;
}

.msg-reply-menu-reply:before {
  background-image: url("../shared/style/headers/images/icons/reply.png");
}

.msg-reply-menu-reply-all:before {
  background-image: url("../shared/style/headers/images/icons/reply_all.png");
}

.msg-reply-menu-forward:before {
  background-image: url("images/icons/forward.png");
}
